
#IMPORTACION DE LIBRERIAS
import serial
import time
from datetime import datetime
import paho.mqtt.publish as publish 

#PUERTO SERIE Y FECHA ACTUAL

data = serial.Serial('/dev/ttyUSB0', 9600)
date = datetime.now()

#ALARMAS DEL SISTEMA

temp_value_1 = 30
temp_value_2 = 27
temp_time = 30 #segundos
temp_alarm_1 = 0        #ALARMA 1 ACTIVA
temp_alarm_2 = 0        #ALARMA 2 ACTIVA
temp_now_1 = int(round(time.time()))

hum_value = 80
hum_alarm = 0           #ALARMA ACTIVA

temp2_value_1 = 37
temp2_value_2 = 20
temp2_time = 30 #segundos
temp2_alarm_1 = 0        #ALARMA 1 ACTIVA
temp2_alarm_2 = 0        #ALARMA 2 ACTIVA
temp2_now_1 = int(round(time.time()))

pres_time = 25 #segundos
pres_alarm = 0           #ALARMA ACTIVA

#BIENVENIDA

print ("")
print ("Bienvenido al Sistema de Monitorizacion")
print (date)
print ("")

#CODIGO PRINCIPAL

while True:
  
  lectura = data.readline() #Lectura del Puerto Serie
 
  if lectura[0] == 'p': #Identificador variable presion
    pres = int(lectura[1])
    if pres == 1 & pres_alarm == 0: #GESTION ALARMA PRESION
      pres_now_1 = int(round(time.time()))
    if pres == 1:
      pres_now_2 = int(round(time.time()))
      pres_time_ = pres_now_2 - pres_now_1
      if pres_time_ > pres_time:
        pres_alarm = 1
    if pres == 0:
      pres_alarm = 0
    
    print ("Sentado: " + str(pres))
    print ("Alarma: " + str(pres_alarm))
    print ("-------------------")
    try:
      publish.single('TFM/dev1/pres', pres, hostname = 'localhost') #Publicacion de valor y alarmas de presion
      publish.single('TFM/dev1/alarm/pres', pres_alarm, hostname = 'localhost')
    except:
      print("Exception ocurred: Publish error!")
	
  elif lectura[0] == 't': #Identificador variable temperatura exterior (habitacion)
    temp = float(lectura[1:6])
    if temp > temp_value_1: #GESTION ALARMA 1 TEMPERATURA EXTERIOR
      temp_alarm_1 = 1
    else:
      temp_alarm_1 = 0
    if temp < temp_value_2: #GESTION ALARMA 2 TEMPERATURA EXTERIOR
      temp_now_1 = int(round(time.time()))
    if temp >= temp_value_2:
      temp_now_2 = int(round(time.time()))
      temp_time_ = temp_now_2 - temp_now_1
      if temp_time_ > temp_time:
        temp_alarm_2 = 1
    if temp < temp_value_2:
      temp_alarm_2 = 0
    
    print ("Temperatura Habitacion: " + str(temp) + " C")
    print ("Alarma 1: " + str(temp_alarm_1))
    print ("Alarma 2: " + str(temp_alarm_2))
    print ("-------------------")
    try:
      publish.single('TFM/dev1/temp', temp, hostname = 'localhost') #Publicacion de valor y alarmas de temperatura exterior
      publish.single('TFM/dev1/alarm/temp_1', temp_alarm_1, hostname = 'localhost')
      publish.single('TFM/dev1/alarm/temp_2', temp_alarm_2, hostname = 'localhost')
    except:
      print("Exception ocurred: Publish error!")
	
  elif lectura[0] == 'h': #Identificador variable humedad interior (cojin)
    hum = float(lectura[1:6])
    if hum > hum_value: #GESTION ALARMA HUMEDAD
      hum_alarm = 1
    else:
      hum_alarm = 0
  
    print ("Humedad Cojin: " + str(hum) + " %")
    print ("Alarma: " + str(hum_alarm))
    print ("-------------------")
    try:
      publish.single('TFM/dev1/hum', hum, hostname = 'localhost') #Publicacion de valor y alarmas de humedad
      publish.single('TFM/dev1/alarm/hum', hum_alarm, hostname = 'localhost')
    except:
      print("Exception ocurred: Publish error!")
	
  elif lectura[0] == 'g': #Identificador variable temperatura interior (cojin)
    temp2 = float(lectura[1:6])
    if temp2 > temp2_value_1: #GESTION ALARMA 1 TEMPERATURA COJIN
      temp2_alarm_1 = 1
    else:
      temp2_alarm_1 = 0
    if temp2 > temp2_value_2: #GESTION ALARMA 2 TEMPERATURA COJIN
      temp2_now_1 = int(round(time.time()))
    if temp2 <= temp2_value_2:
      temp2_now_2 = int(round(time.time()))
      temp2_time_ = temp2_now_2 - temp2_now_1
      if temp2_time_ > temp2_time:
        temp2_alarm_2 = 1
    if temp2 > temp2_value_2:
      temp2_alarm_2 = 0
      
    print ("Temperatura Cojin: " + str(temp2) + " C")
    print ("Alarma 1: " + str(temp2_alarm_1))
    print ("Alarma 2: " + str(temp2_alarm_2))
    print ("-------------------")
    try:
      publish.single('TFM/dev1/temp2', temp2, hostname = 'localhost') #Publicacion de valor y alarmas de temperatura cojin
      publish.single('TFM/dev1/alarm/temp2_1', temp2_alarm_1, hostname = 'localhost')
      publish.single('TFM/dev1/alarm/temp2_2', temp2_alarm_2, hostname = 'localhost')
    except:
      print("Exception ocurred: Publish error!")
